Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::Camera Class Reference

A viewpoint from which the scene will be rendered. More...

`#include <OgreCamera.h>`

Inheritance diagram for Ogre::Camera:

[legend]
List of all members.

## Public Types
typedef std::vector< ShadowRenderable * > | ShadowRenderableList
typedef VectorIterator< ShadowRenderableList > | ShadowRenderableListIterator
## Public Member Functions
| Camera (const String &name, SceneManager *sm)
| Standard constructor.
virtual | ~Camera ()
| Standard destructor.
SceneManager * | getSceneManager (void) const
| Returns a pointer to the SceneManager this camera is rendering through.
virtual const String & | getName (void) const
| Gets the camera's name.
void | setPolygonMode (PolygonMode sd)
| Sets the level of rendering detail required from this camera.
PolygonMode | getPolygonMode (void) const
| Retrieves the level of detail that the camera will render.
void | setPosition (Real x, Real y, Real z)
| Sets the camera's position.
void | setPosition (const Vector3 &vec)
| Sets the camera's position.
const Vector3 & | getPosition (void) const
| Retrieves the camera's position.
void | move (const Vector3 &vec)
| Moves the camera's position by the vector offset provided along world axes.
void | moveRelative (const Vector3 &vec)
| Moves the camera's position by the vector offset provided along it's own axes (relative to orientation).
void | setDirection (Real x, Real y, Real z)
| Sets the camera's direction vector.
void | setDirection (const Vector3 &vec)
| Sets the camera's direction vector.
Vector3 | getDirection (void) const
Vector3 | getUp (void) const
| Gets the camera's up vector.
Vector3 | getRight (void) const
| Gets the camera's right vector.
void | lookAt (const Vector3 &targetPoint)
| Points the camera at a location in worldspace.
void | lookAt (Real x, Real y, Real z)
| Points the camera at a location in worldspace.
void | roll (const Radian &angle)
| Rolls the camera anticlockwise, around its local z axis.
void | yaw (const Radian &angle)
| Rotates the camera anticlockwise around it's local y axis.
void | pitch (const Radian &angle)
| Pitches the camera up/down anticlockwise around it's local z axis.
void | rotate (const Vector3 &axis, const Radian &angle)
| Rotate the camera around an arbitrary axis.
void | rotate (const Quaternion &q)
| Rotate the camera around an aritrary axis using a Quarternion.
void | setFixedYawAxis (bool useFixed, const Vector3 &fixedAxis=Vector3::UNIT_Y)
| Tells the camera whether to yaw around it's own local Y axis or a fixed axis of choice.
const Quaternion & | getOrientation (void) const
| Returns the camera's current orientation.
void | setOrientation (const Quaternion &q)
| Sets the camera's orientation.
void | _renderScene (Viewport *vp, bool includeOverlays)
| Tells the Camera to contact the SceneManager to render from it's viewpoint.
void | _notifyRenderedFaces (unsigned int numfaces)
| Internal method to notify camera of the visible faces in the last render.
void | _notifyRenderedBatches (unsigned int numbatches)
| Internal method to notify camera of the visible batches in the last render.
unsigned int | _getNumRenderedFaces (void) const
| Internal method to retrieve the number of visible faces in the last render.
unsigned int | _getNumRenderedBatches (void) const
| Internal method to retrieve the number of visible batches in the last render.
const Quaternion & | getDerivedOrientation (void) const
| Gets the derived orientation of the camera, including any rotation inherited from a node attachment and reflection matrix.
const Vector3 & | getDerivedPosition (void) const
| Gets the derived position of the camera, including any translation inherited from a node attachment and reflection matrix.
Vector3 | getDerivedDirection (void) const
| Gets the derived direction vector of the camera, including any rotation inherited from a node attachment and reflection matrix.
Vector3 | getDerivedUp (void) const
| Gets the derived up vector of the camera, including any rotation inherited from a node attachment and reflection matrix.
Vector3 | getDerivedRight (void) const
| Gets the derived right vector of the camera, including any rotation inherited from a node attachment and reflection matrix.
const Quaternion & | getRealOrientation (void) const
| Gets the real world orientation of the camera, including any rotation inherited from a node attachment.
const Vector3 & | getRealPosition (void) const
| Gets the real world position of the camera, including any translation inherited from a node attachment.
Vector3 | getRealDirection (void) const
| Gets the real world direction vector of the camera, including any rotation inherited from a node attachment.
Vector3 | getRealUp (void) const
| Gets the real world up vector of the camera, including any rotation inherited from a node attachment.
Vector3 | getRealRight (void) const
| Gets the real world right vector of the camera, including any rotation inherited from a node attachment.
const String & | getMovableType (void) const
| Overridden from MovableObject.
void | setAutoTracking (bool enabled, SceneNode *target=0, const Vector3 &offset=Vector3::ZERO)
| Enables / disables automatic tracking of a SceneNode.
void | setLodBias (Real factor=1.0)
| Sets the level-of-detail factor for this Camera.
Real | getLodBias (void) const
| Returns the level-of-detail bias factor currently applied to this camera.
Ray | getCameraToViewportRay (Real screenx, Real screeny) const
| Gets a world space ray as cast from the camera through a viewport position.
Real | _getLodBiasInverse (void) const
| Internal method for OGRE to use for LOD calculations.
void | _autoTrack (void)
| Internal method used by OGRE to update auto-tracking cameras.
virtual void | setWindow (Real Left, Real Top, Real Right, Real Bottom)
| Sets the viewing window inside of viewport.
virtual void | resetWindow (void)
| Cancel view window.
virtual bool | isWindowSet (void) const
| Returns if a viewport window is being used.
const std::vector< Plane > & | getWindowPlanes (void) const
| Gets the window clip planes, only applicable if isWindowSet == true.
Real | getBoundingRadius (void) const
| Overridden from MovableObject.
SceneNode * | getAutoTrackTarget (void) const
| Get the auto tracking target for this camera, if any.
const Vector3 & | getAutoTrackOffset (void) const
| Get the auto tracking offset for this camera, if it is auto tracking.
Viewport * | getViewport (void) const
| Get the last viewport which was attached to this camera.
void | _notifyViewport (Viewport *viewport)
| Notifies this camera that a viewport is using it.
void | setAutoAspectRatio (bool autoratio)
| If set to true a vieport that owns this frustum will be able to recalculate the aspect ratio whenever the frustum is resized.
bool | getAutoAspectRatio (void) const
| Retreives if AutoAspectRatio is currently set or not.
void | setCullingFrustum (Frustum *frustum)
| Tells the camera to use a separate Frustum instance to perform culling.
Frustum * | getCullingFrustum (void)
| Returns the custom culling frustum in use.
virtual void | forwardIntersect (const Plane &worldPlane, std::vector< Vector4 > *intersect3d) const
| Forward projects frustum rays to find forward intersection with plane.
bool | isVisible (const AxisAlignedBox &bound, FrustumPlane *culledBy=0) const
  | Parameters:
  | bound | Bounding box to be checked (world space)
  | culledBy | Optional pointer to an int which will be filled by the plane number which culled the box if the result was false;
Returns: If the box was visible, true is returned. Otherwise, false is returned.
bool | isVisible (const Sphere &bound, FrustumPlane *culledBy=0) const
  | Parameters:
  | bound | Bounding box to be checked (world space)
  | culledBy | Optional pointer to an int which will be filled by the plane number which culled the box if the result was false;
Returns: If the box was visible, true is returned. Otherwise, false is returned.
bool | isVisible (const Vector3 &vert, FrustumPlane *culledBy=0) const
  | Parameters:
  | bound | Bounding box to be checked (world space)
  | culledBy | Optional pointer to an int which will be filled by the plane number which culled the box if the result was false;
Returns: If the box was visible, true is returned. Otherwise, false is returned.
const Vector3 * | getWorldSpaceCorners (void) const
| Remarks: The corners are ordered as follows: top-right near, top-left near, bottom-left near, bottom-right near, top-right far, top-left far, bottom-left far, bottom-right far.
const Plane & | getFrustumPlane (unsigned short plane) const
| Remarks: Gets a reference to one of the planes which make up the frustum frustum, e.g. for clipping purposes.
bool | projectSphere (const Sphere &sphere, Real *left, Real *top, Real *right, Real *bottom) const
  | Parameters:
  | sphere | The world-space sphere to project
  | radius | Radius of the sphere
  | left,top,right,bottom | Pointers to destination values, these will be completed with the normalised device coordinates (in the range {-1,1})
Returns: true if the sphere was projected to a subset of the near plane, false if the entire near plane was contained
Real | getNearClipDistance (void) const
Real | getFarClipDistance (void) const
const Matrix4 & | getViewMatrix (void) const
| Mainly for use by OGRE internally.
const Matrix4 & | getViewMatrix (bool ownFrustumOnly) const
| Specialised version of getViewMatrix allowing caller to differentiate whether the custom culling frustum should be allowed or not.
virtual void | setUseRenderingDistance (bool use)
| Set whether this camera should use the 'rendering distance' on objects to exclude distant objects from the final image.
virtual bool | getUseRenderingDistance (void) const
| Get whether this camera should use the 'rendering distance' on objects to exclude distant objects from the final image.
virtual void | setFOVy (const Radian &fovy)
| Sets the Y-dimension Field Of View (FOV) of the frustum.
virtual const Radian & | getFOVy (void) const
| Retrieves the frustums Y-dimension Field Of View (FOV).
virtual void | setNearClipDistance (Real nearDist)
| Sets the position of the near clipping plane.
virtual void | setFarClipDistance (Real farDist)
| Sets the distance to the far clipping plane.
virtual void | setAspectRatio (Real ratio)
| Sets the aspect ratio for the frustum viewport.
virtual Real | getAspectRatio (void) const
| Retreives the current aspect ratio.
virtual void | setFrustumOffset (const Vector2 &offset)
| Sets frustum offsets, used in stereo rendering.
virtual void | setFrustumOffset (Real horizontal=0.0, Real vertical=0.0)
| Sets frustum offsets, used in stereo rendering.
virtual const Vector2 & | getFrustumOffset () const
| Retreives the frustum offsets.
virtual void | setFocalLength (Real focalLength=1.0)
| Sets frustum focal length (used in stereo rendering).
virtual Real | getFocalLength () const
| Returns focal length of frustum.
virtual const Matrix4 & | getProjectionMatrixRS (void) const
| Gets the projection matrix for this frustum adjusted for the current rendersystem specifics (may be right or left-handed, depth range may vary).
virtual const Matrix4 & | getProjectionMatrixWithRSDepth (void) const
| Gets the depth-adjusted projection matrix for the current rendersystem, but one which still conforms to right-hand rules.
virtual const Matrix4 & | getProjectionMatrix (void) const
| Gets the normal projection matrix for this frustum, ie the projection matrix which conforms to standard right-handed rules and uses depth range [-1,+1].
virtual void | setCustomViewMatrix (bool enable, const Matrix4 &viewMatrix=Matrix4::IDENTITY)
| Set whether to use a custom view matrix on this frustum.
virtual bool | isCustomViewMatrixEnabled (void) const
| Returns whether a custom view matrix is in use.
virtual void | setCustomProjectionMatrix (bool enable, const Matrix4 &projectionMatrix=Matrix4::IDENTITY)
| Set whether to use a custom projection matrix on this frustum.
virtual bool | isCustomProjectionMatrixEnabled (void) const
| Returns whether a custom projection matrix is in use.
virtual const Plane * | getFrustumPlanes (void) const
| Retrieves the clipping planes of the frustum (world space).
virtual bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
const AxisAlignedBox & | getBoundingBox (void) const
| Overridden from MovableObject.
void | _updateRenderQueue (RenderQueue *queue)
| Overridden from MovableObject.
void | _notifyCurrentCamera (Camera *cam)
| Overridden from MovableObject.
const MaterialPtr & | getMaterial (void) const
| Overridden from Renderable.
void | getRenderOperation (RenderOperation &op)
| Overridden from Renderable.
void | getWorldTransforms (Matrix4 *xform) const
| Overridden from Renderable.
const Quaternion & | getWorldOrientation (void) const
| Overridden from Renderable.
const Vector3 & | getWorldPosition (void) const
| Overridden from Renderable.
Real | getSquaredViewDepth (const Camera *cam) const
| Overridden from Renderable.
const LightList & | getLights (void) const
| Overridden from Renderable.
virtual void | setProjectionType (ProjectionType pt)
| Sets the type of projection to use (orthographic or perspective).
virtual ProjectionType | getProjectionType (void) const
| Retrieves info on the type of projection used (orthographic or perspective).
virtual void | enableReflection (const Plane &p)
| Modifies this frustum so it always renders from the reflection of itself through the plane specified.
virtual void | enableReflection (const MovablePlane *p)
| Modifies this frustum so it always renders from the reflection of itself through the plane specified.
virtual void | disableReflection (void)
| Disables reflection modification previously turned on with enableReflection.
virtual bool | isReflected (void) const
| Returns whether this frustum is being reflected.
virtual const Matrix4 & | getReflectionMatrix (void) const
| Returns the reflection matrix of the frustum if appropriate.
virtual const Plane & | getReflectionPlane (void) const
| Returns the reflection plane of the frustum if appropriate.
virtual void | enableCustomNearClipPlane (const MovablePlane *plane)
| Links the frustum to a custom near clip plane, which can be used to clip geometry in a custom manner without using user clip planes.
virtual void | enableCustomNearClipPlane (const Plane &plane)
| Links the frustum to a custom near clip plane, which can be used to clip geometry in a custom manner without using user clip planes.
virtual void | disableCustomNearClipPlane (void)
| Disables any custom near clip plane.
virtual bool | isCustomNearClipPlaneEnabled (void) const
| Is a custom near clip plane in use?
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual Node * | getParentNode (void) const
| Returns the node to which this object is attached.
virtual SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
virtual void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Internal method called to notify the object that it has been attached to a node.
virtual bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
virtual void | _notifyMoved (void)
| Internal method called to notify the object that it has been moved.
virtual const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
virtual void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
virtual bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
virtual void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
virtual Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
virtual void | setUserObject (UserDefinedObject *obj)
| Call this to associate your own custom user object instance with this MovableObject.
virtual UserDefinedObject * | getUserObject (void)
| Retrieves a pointer to a custom application object associated with this movable by an earlier call to setUserObject.
virtual void | setUserAny (const Any &anything)
| Sets any kind of user value on this object.
virtual const Any & | getUserAny (void) const
| Retrieves the custom user value associated with this object.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
virtual uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
virtual const Matrix4 & | _getParentNodeFullTransform (void) const
| return the full transformation of the parent sceneNode or the attachingPoint node
virtual void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
virtual void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeQueryFlags (unsigned long flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
virtual void | setVisibilityFlags (uint32 flags)
| Sets the visiblity flags for this object.
virtual void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
virtual void | setListener (Listener *listener)
| Sets a listener for this object.
virtual Listener * | getListener (void) const
| Gets the current listener for this object.
virtual const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
EdgeData * | getEdgeList (void)
| Define a default implementation of method from ShadowCaster which implements no shadows.
bool | hasEdgeList (void)
| Define a default implementation of method from ShadowCaster which implements no shadows.
ShadowRenderableListIterator | getShadowVolumeRenderableIterator (ShadowTechnique shadowTechnique, const Light *light, HardwareIndexBufferSharedPtr *indexBuffer, bool extrudeVertices, Real extrusionDist, unsigned long flags=0)
| Define a default implementation of method from ShadowCaster which implements no shadows.
const AxisAlignedBox & | getLightCapBounds (void) const
| Overridden member from ShadowCaster.
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Overridden member from ShadowCaster.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
bool | getCastShadows (void) const
| Returns whether shadow casting is enabled for this object.
Real | getPointExtrusionDistance (const Light *l) const
| Get the distance to extrude for a point/spot light.
virtual uint32 | getTypeFlags (void) const
| Get the 'type flags' for this MovableObject.
const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
virtual unsigned short | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
virtual bool | getNormaliseNormals (void) const
| Returns whether or not this Renderable wishes the hardware to normalise normals.
virtual const PlaneList & | getClipPlanes () const
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
## Static Public Member Functions
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.
## Static Public Attributes
static const Real | INFINITE_FAR_PLANE_ADJUST
| Small constant used to reduce far plane projection to avoid inaccuracies.
## Protected Types
typedef std::map< String, StringVector > | AnimableDictionaryMap
typedef std::map< size_t, Vector4 > | CustomParameterMap
## Protected Member Functions
bool | isViewOutOfDate (void) const
void | invalidateFrustum (void) const
| Signal to update frustum information.
void | invalidateView (void) const
| Signal to update view information.
virtual void | setWindowImpl (void) const
| Do actual window setting, using parameters set in SetWindow call.
const Vector3 & | getPositionForViewUpdate (void) const
| Get the derived position of this frustum.
const Quaternion & | getOrientationForViewUpdate (void) const
| Get the derived orientation of this frustum.
virtual std::vector< Vector4 > | getRayForwardIntersect (const Vector3 &anchor, const Vector3 *dir, Real planeOffset) const
| Helper function for forwardIntersect that intersects rays with canonical plane.
virtual void | calcProjectionParameters (Real &left, Real &right, Real &bottom, Real &top) const
virtual void | updateFrustum (void) const
| Update frustum if out of date.
virtual void | updateView (void) const
| Update view if out of date.
virtual void | updateFrustumImpl (void) const
| Implementation of updateFrustum (called if out of date).
virtual void | updateViewImpl (void) const
| Implementation of updateView (called if out of date).
virtual void | updateFrustumPlanes (void) const
virtual void | updateFrustumPlanesImpl (void) const
| Implementation of updateFrustumPlanes (called if out of date).
virtual void | updateWorldSpaceCorners (void) const
virtual void | updateWorldSpaceCornersImpl (void) const
| Implementation of updateWorldSpaceCorners (called if out of date).
virtual void | updateVertexData (void) const
virtual bool | isFrustumOutOfDate (void) const
Real | getExtrusionDistance (const Vector3 &objectPos, const Light *light) const
| Helper moethod for calculating extrusion distance.
virtual void | updateEdgeListLightFacing (EdgeData *edgeData, const Vector4 &lightPos)
| Tells the caster to perform the tasks necessary to update the edge data's light listing.
virtual void | generateShadowVolume (EdgeData *edgeData, const HardwareIndexBufferSharedPtr &indexBuffer, const Light *light, ShadowRenderableList &shadowRenderables, unsigned long flags)
| Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.
virtual void | extrudeBounds (AxisAlignedBox &box, const Vector4 &lightPos, Real extrudeDist) const
| Utility method for extruding a bounding box.
virtual const String & | getAnimableDictionaryName (void) const
| Get the name of the animable dictionary for this class.
void | createAnimableDictionary (void) const
| Internal method for creating a dictionary of animable value names for the class, if it does not already exist.
StringVector & | _getAnimableValueNames (void)
| Get an updateable reference to animable value list.
virtual void | initialiseAnimableDictionary (StringVector &) const
| Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters.
## Protected Attributes
String | mName
| Camera name.
SceneManager * | mSceneMgr
| Scene manager responsible for the scene.
Quaternion | mOrientation
| Camera orientation, quaternion style.
Vector3 | mPosition
| Camera position - default (0,0,0).
Quaternion | mDerivedOrientation
| Derived orientation/position of the camera, including reflection.
Vector3 | mDerivedPosition
Quaternion | mRealOrientation
| Real world orientation/position of the camera.
Vector3 | mRealPosition
bool | mYawFixed
| Whether to yaw around a fixed axis.
Vector3 | mYawFixedAxis
| Fixed axis to yaw around.
PolygonMode | mSceneDetail
| Rendering type.
unsigned int | mVisFacesLastRender
| Stored number of visible faces in the last render.
unsigned int | mVisBatchesLastRender
| Stored number of visible faces in the last render.
SceneNode * | mAutoTrackTarget
| SceneNode which this Camera will automatically track.
Vector3 | mAutoTrackOffset
| Tracking offset for fine tuning.
Real | mSceneLodFactor
Real | mSceneLodFactorInv
| Inverted scene LOD factor, can be used by Renderables to adjust their LOD.
Real | mWLeft
| Viewing window.
Real | mWTop
| Viewing window.
Real | mWRight
| Viewing window.
Real | mWBottom
| Viewing window.
bool | mWindowSet
| Is viewing window used.
std::vector< Plane > | mWindowClipPlanes
| Windowed viewport clip planes.
bool | mRecalcWindow
Viewport * | mLastViewport
| The last viewport to be added using this camera.
bool | mAutoAspectRatio
| Whether aspect ratio will automaticaally be recalculated when a vieport changes its size.
Frustum * | mCullFrustum
| Custom culling frustum.
bool | mUseRenderingDistance
| Whether or not the rendering distance of objects should take effect for this camera.
ProjectionType | mProjType
| Orthographic or perspective?
Radian | mFOVy
| y-direction field-of-view (default 45)
Real | mFarDist
| Far clip distance - default 10000.
Real | mNearDist
| Near clip distance - default 100.
Real | mAspect
| x/y viewport ratio - default 1.3333
Vector2 | mFrustumOffset
| Off-axis frustum center offset - default (0.0, 0.0).
Real | mFocalLength
| Focal length of frustum (for stereo rendering, defaults to 1.0).
Plane | mFrustumPlanes [6]
| The 6 main clipping planes.
Quaternion | mLastParentOrientation
| Stored versions of parent orientation / position.
Vector3 | mLastParentPosition
Matrix4 | mProjMatrixRS
| Pre-calced projection matrix for the specific render system.
Matrix4 | mProjMatrixRSDepth
| Pre-calced standard projection matrix but with render system depth range.
Matrix4 | mProjMatrix
| Pre-calced standard projection matrix.
Matrix4 | mViewMatrix
| Pre-calced view matrix.
bool | mRecalcFrustum
| Something's changed in the frustrum shape?
bool | mRecalcView
| Something re the view pos has changed.
bool | mRecalcFrustumPlanes
| Something re the frustum planes has changed.
bool | mRecalcWorldSpaceCorners
| Something re the world space corners has changed.
bool | mRecalcVertexData
| Something re the vertex data has changed.
bool | mCustomViewMatrix
| Are we using a custom view matrix?
bool | mCustomProjMatrix
| Are we using a custom projection matrix?
AxisAlignedBox | mBoundingBox
VertexData | mVertexData
MaterialPtr | mMaterial
Vector3 | mWorldSpaceCorners [8]
bool | mReflect
| Is this frustum to act as a reflection of itself?
Matrix4 | mReflectMatrix
| Derived reflection matrix.
Plane | mReflectPlane
| Fixed reflection plane.
const MovablePlane * | mLinkedReflectPlane
| Pointer to a reflection plane (automatically updated).
Plane | mLastLinkedReflectionPlane
| Record of the last world-space reflection plane info used.
bool | mObliqueDepthProjection
| Is this frustum using an oblique depth projection?
Plane | mObliqueProjPlane
| Fixed oblique projection plane.
const MovablePlane * | mLinkedObliqueProjPlane
| Pointer to oblique projection plane (automatically updated).
Plane | mLastLinkedObliqueProjPlane
| Record of the last world-space oblique depth projection plane info used.
MovableObjectFactory * | mCreator
| Creator of this object (if created by a factory).
SceneManager * | mManager
| SceneManager holding this object (if applicable).
Node * | mParentNode
| node to which this object is attached
bool | mParentIsTagPoint
bool | mVisible
| Is this object visible?
Real | mUpperDistance
| Upper distance to still render.
Real | mSquaredUpperDistance
bool | mBeyondFarDistance
| Hidden because of distance?
Any | mUserAny
| User defined link to another object / value / whatever.
uint8 | mRenderQueueID
| The render queue to use when rendering this object.
bool | mRenderQueueIDSet
| Flags whether the RenderQueue's default should be used.
uint32 | mQueryFlags
| Flags determining whether this object is included / excluded from scene queries.
uint32 | mVisibilityFlags
| Flags determining whether this object is visible (compared to SceneManager mask).
AxisAlignedBox | mWorldAABB
| Cached world AABB of this object.
Sphere | mWorldBoundingSphere
AxisAlignedBox | mWorldDarkCapBounds
| World space AABB of this object's dark cap.
bool | mCastShadows
| Does this object cast shadows?
bool | mRenderingDisabled
| Does rendering this object disabled by listener?
Listener * | mListener
| MovableObject listener - only one allowed (no list) for size & performance reasons. */.
LightList | mLightList
| List of lights for this object.
ulong | mLightListUpdated
| The last frame that this light list was updated in.
CustomParameterMap | mCustomParameters
bool | mPolygonModeOverrideable
bool | mUseIdentityProjection
bool | mUseIdentityView
## Static Protected Attributes
static String | msMovableType
| Shared class-level name for Movable type.
static uint32 | msDefaultQueryFlags
| Default query flags.
static uint32 | msDefaultVisibilityFlags
| Default visibility flags.
static AnimableDictionaryMap | msAnimableDictionary
| Static map of class name to list of animable value names.
static const PlaneList | msDummyPlaneList
## Friends
_OgreExport friend std::ostream & | operator<< (std::ostream &o, const Camera &c)
| Function for outputting to a stream.

## Detailed Description

A viewpoint from which the scene will be rendered.

Remarks:
  OGRE renders scenes from a camera viewpoint into a buffer of some sort, normally a window or a texture (a subclass of RenderTarget). OGRE cameras support both perspective projection (the default, meaning objects get smaller the further away they are) and orthographic projection (blueprint-style, no decrease in size with distance). Each camera carries with it a style of rendering, e.g. full textured, flat shaded, wireframe), field of view, rendering distances etc, allowing you to use OGRE to create complex multi-window views if required. In addition, more than one camera can point at a single render target if required, each rendering to a subset of the target, allowing split screen and picture-in-picture views.

  Cameras maintain their own aspect ratios, field of view, and frustrum, and project co-ordinates into a space measured from -1 to 1 in x and y, and 0 to 1 in z. At render time, the camera will be rendering to a Viewport which will translate these parametric co-ordinates into real screen co-ordinates. Obviously it is advisable that the viewport has the same aspect ratio as the camera to avoid distortion (unless you want it!).

  Note that a Camera can be attached to a SceneNode, using the method SceneNode::attachObject. If this is done the Camera will combine it's own position/orientation settings with it's parent SceneNode. This is useful for implementing more complex Camera / object relationships i.e. having a camera attached to a world object.

Definition at line 80 of file OgreCamera.h.

## Member Typedef Documentation

typedef std::map<String, StringVector> Ogre::AnimableObject::AnimableDictionaryMap`[protected, inherited]`

| Definition at line 206 of file OgreAnimable.h.

typedef std::map<size_t, Vector4> Ogre::Renderable::CustomParameterMap`[protected, inherited]`

| Definition at line 285 of file OgreRenderable.h.

typedef std::vector<ShadowRenderable*> Ogre::ShadowCaster::ShadowRenderableList`[inherited]`

| Definition at line 127 of file OgreShadowCaster.h.

typedef VectorIterator<ShadowRenderableList> Ogre::ShadowCaster::ShadowRenderableListIterator`[inherited]`

| Definition at line 128 of file OgreShadowCaster.h.

## Constructor & Destructor Documentation

Ogre::Camera::Camera | ( | const String & | name,
|  | SceneManager * | sm
| ) |

| Standard constructor.

virtual Ogre::Camera::~Camera | ( |  | ) | `[virtual]`

| Standard destructor.

## Member Function Documentation

void Ogre::Camera::_autoTrack | ( | void |  | ) |

| Internal method used by OGRE to update auto-tracking cameras.

StringVector& Ogre::AnimableObject::_getAnimableValueNames | ( | void |  | ) | `[protected, inherited]`

| Get an updateable reference to animable value list. Definition at line 232 of file OgreAnimable.h. References OGRE_EXCEPT.

virtual MovableObjectFactory* Ogre::MovableObject::_getCreator | ( | void |  | ) | const`[virtual, inherited]`

| Get the creator of this object, if any (internal use only). Definition at line 166 of file OgreMovableObject.h.

Real Ogre::Camera::_getLodBiasInverse | ( | void |  | ) | const

| Internal method for OGRE to use for LOD calculations.

virtual SceneManager* Ogre::MovableObject::_getManager | ( | void |  | ) | const`[virtual, inherited]`

| Get the manager of this object, if any (internal use only). Definition at line 170 of file OgreMovableObject.h.

unsigned int Ogre::Camera::_getNumRenderedBatches | ( | void |  | ) | const

| Internal method to retrieve the number of visible batches in the last render.

unsigned int Ogre::Camera::_getNumRenderedFaces | ( | void |  | ) | const

| Internal method to retrieve the number of visible faces in the last render.

virtual const Matrix4& Ogre::MovableObject::_getParentNodeFullTransform | ( | void |  | ) | const`[virtual, inherited]`

| return the full transformation of the parent sceneNode or the attachingPoint node

virtual void Ogre::MovableObject::_notifyAttached | ( | Node * | parent,
|  | bool | isTagPoint = `false`
| ) | `[virtual, inherited]`

| Internal method called to notify the object that it has been attached to a node. Reimplemented in Ogre::Entity, Ogre::Light, and Ogre::ParticleSystem.

virtual void Ogre::MovableObject::_notifyCreator | ( | MovableObjectFactory * | fact | ) | `[virtual, inherited]`

| Notify the object of it's creator (internal use only). Definition at line 164 of file OgreMovableObject.h.

void Ogre::Frustum::_notifyCurrentCamera | ( | Camera * | cam | ) | `[virtual, inherited]`

| Overridden from MovableObject. Reimplemented from Ogre::MovableObject.

virtual void Ogre::MovableObject::_notifyManager | ( | SceneManager * | man | ) | `[virtual, inherited]`

| Notify the object of it's manager (internal use only). Definition at line 168 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::_notifyMoved | ( | void |  | ) | `[virtual, inherited]`

| Internal method called to notify the object that it has been moved. Reimplemented in Ogre::Light.

void Ogre::Camera::_notifyRenderedBatches | ( | unsigned int | numbatches | ) |

| Internal method to notify camera of the visible batches in the last render.

void Ogre::Camera::_notifyRenderedFaces | ( | unsigned int | numfaces | ) |

| Internal method to notify camera of the visible faces in the last render.

void Ogre::Camera::_notifyViewport | ( | Viewport * | viewport | ) |

| Notifies this camera that a viewport is using it. Definition at line 488 of file OgreCamera.h.

void Ogre::Camera::_renderScene | ( | Viewport * | vp,
|  | bool | includeOverlays
| ) |

  | Tells the Camera to contact the SceneManager to render from it's viewpoint. Parameters:
  | vp | The viewport to render to
  | includeOverlays | Whether or not any overlay objects should be included

virtual void Ogre::Renderable::_updateCustomGpuParameter | ( | const GpuProgramParameters::AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params
| ) | const`[virtual, inherited]`

  | Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows. Remarks: This method allows a Renderable to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_CUSTOM, and to allow there to be more than one of these per Renderable, the 'data' field on the auto parameter will identify which parameter is being updated. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object, using the details provided in the incoming auto constant setting to identify the index at which to set the parameter. You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case. Parameters:
  | constantEntry | The auto constant entry referring to the parameter being updated
  | params | The parameters object which this method should call to set the updated parameters.
Reimplemented in Ogre::SubEntity. Definition at line 252 of file OgreRenderable.h.

void Ogre::Frustum::_updateRenderQueue | ( | RenderQueue * | queue | ) | `[virtual, inherited]`

| Overridden from MovableObject. Implements Ogre::MovableObject.

virtual void Ogre::MovableObject::addQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object. Definition at line 338 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::addVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object. Definition at line 366 of file OgreMovableObject.h.

virtual void Ogre::Frustum::calcProjectionParameters | ( | Real & | left,
|  | Real & | right,
|  | Real & | bottom,
|  | Real & | top
| ) | const`[protected, virtual, inherited]`

void Ogre::AnimableObject::createAnimableDictionary | ( | void |  | ) | const`[protected, inherited]`

| Internal method for creating a dictionary of animable value names for the class, if it does not already exist. Definition at line 219 of file OgreAnimable.h.

virtual AnimableValuePtr Ogre::AnimableObject::createAnimableValue | ( | const String & | valueName | ) | `[virtual, inherited]`

| Create a reference-counted AnimableValuePtr for the named value. Remarks: You can use the returned object to animate a value on this object, using AnimationTrack. Subclasses must override this if they wish to support animation of their values. Reimplemented in Ogre::Light. Definition at line 285 of file OgreAnimable.h. References OGRE_EXCEPT.

virtual void Ogre::Frustum::disableCustomNearClipPlane | ( | void |  | ) | `[virtual, inherited]`

| Disables any custom near clip plane.

virtual void Ogre::Frustum::disableReflection | ( | void |  | ) | `[virtual, inherited]`

| Disables reflection modification previously turned on with enableReflection.

virtual void Ogre::Frustum::enableCustomNearClipPlane | ( | const Plane & | plane | ) | `[virtual, inherited]`

  | Links the frustum to a custom near clip plane, which can be used to clip geometry in a custom manner without using user clip planes. Remarks: There are several applications for clipping a scene arbitrarily by a single plane; the most common is when rendering a reflection to a texture, and you only want to render geometry that is above the water plane (to do otherwise results in artefacts). Whilst it is possible to use user clip planes, they are not supported on all cards, and sometimes are not hardware accelerated when they are available. Instead, where a single clip plane is involved, this technique uses a 'fudging' of the near clip plane, which is available and fast on all hardware, to perform as the arbitrary clip plane. This does change the shape of the frustum, leading to some depth buffer loss of precision, but for many of the uses of this technique that is not an issue. Note: This technique only works for perspective projection. Parameters:
  | plane | The plane to link to to perform the clipping. This plane must continue to exist while the camera is linked to it; do not destroy it before the frustum.

virtual void Ogre::Frustum::enableCustomNearClipPlane | ( | const MovablePlane * | plane | ) | `[virtual, inherited]`

  | Links the frustum to a custom near clip plane, which can be used to clip geometry in a custom manner without using user clip planes. Remarks: There are several applications for clipping a scene arbitrarily by a single plane; the most common is when rendering a reflection to a texture, and you only want to render geometry that is above the water plane (to do otherwise results in artefacts). Whilst it is possible to use user clip planes, they are not supported on all cards, and sometimes are not hardware accelerated when they are available. Instead, where a single clip plane is involved, this technique uses a 'fudging' of the near clip plane, which is available and fast on all hardware, to perform as the arbitrary clip plane. This does change the shape of the frustum, leading to some depth buffer loss of precision, but for many of the uses of this technique that is not an issue. This version of the method links to a plane, rather than requiring a by-value plane definition, and therefore you can make changes to the plane (e.g. by moving / rotating the node it is attached to) and they will automatically affect this object. Note: This technique only works for perspective projection. Parameters:
  | plane | The plane to link to to perform the clipping. This plane must continue to exist while the camera is linked to it; do not destroy it before the frustum.

virtual void Ogre::Frustum::enableReflection | ( | const MovablePlane * | p | ) | `[virtual, inherited]`

| Modifies this frustum so it always renders from the reflection of itself through the plane specified. Note that this version of the method links to a plane so that changes to it are picked up automatically. It is important that this plane continues to exist whilst this object does; do not destroy the plane before the frustum. Remarks: This is obviously useful for performing planar reflections.

virtual void Ogre::Frustum::enableReflection | ( | const Plane & | p | ) | `[virtual, inherited]`

| Modifies this frustum so it always renders from the reflection of itself through the plane specified. Remarks: This is obviously useful for performing planar reflections.

virtual void Ogre::ShadowCaster::extrudeBounds | ( | AxisAlignedBox & | box,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist
| ) | const`[protected, virtual, inherited]`

  | Utility method for extruding a bounding box. Parameters:
  | box | Original bounding box, will be updated in-place
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

static void Ogre::ShadowCaster::extrudeVertices | ( | const HardwareVertexBufferSharedPtr & | vertexBuffer,
|  | size_t | originalVertexCount,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist
| ) | `[static, inherited]`

  | Utility method for extruding vertices based on a light. Remarks: Unfortunately, because D3D cannot handle homogenous (4D) position coordinates in the fixed-function pipeline (GL can, but we have to be cross-API), when we extrude in software we cannot extrude to infinity the way we do in the vertex program (by setting w to 0.0f). Therefore we extrude by a fixed distance, which may cause some problems with larger scenes. Luckily better hardware (ie vertex programs) can fix this. Parameters:
  | vertexBuffer | The vertex buffer containing ONLY xyz position values, which must be originalVertexCount * 2 * 3 floats long.
  | originalVertexCount | The count of the original number of vertices, ie the number in the mesh, not counting the doubling which has already been done (by VertexData::prepareForShadowVolume) to provide the extruded area of the buffer.
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

virtual void Ogre::Camera::forwardIntersect | ( | const Plane & | worldPlane,
|  | std::vector< Vector4 > * | intersect3d
| ) | const`[virtual]`

| Forward projects frustum rays to find forward intersection with plane. Remarks: Forward projection may lead to intersections at infinity.

virtual void Ogre::ShadowCaster::generateShadowVolume | ( | EdgeData * | edgeData,
|  | const HardwareIndexBufferSharedPtr & | indexBuffer,
|  | const Light * | light,
|  | ShadowRenderableList & | shadowRenderables,
|  | unsigned long | flags
| ) | `[protected, virtual, inherited]`

  | Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it. Parameters:
  | edgeData | The edge information to use
  | indexBuffer | The buffer into which to write data into; current contents are assumed to be discardable.
  | light | The light, mainly for type info as silhouette calculations should already have been done in updateEdgeListLightFacing
  | shadowRenderables | A list of shadow renderables which has already been constructed but will need populating with details of the index ranges to be used.
  | flags | Additional controller flags, see ShadowRenderableFlags

virtual const String& Ogre::AnimableObject::getAnimableDictionaryName | ( | void |  | ) | const`[protected, virtual, inherited]`

| Get the name of the animable dictionary for this class. Remarks: Subclasses must override this if they want to support animation of their values. Reimplemented in Ogre::Light. Definition at line 214 of file OgreAnimable.h.

const StringVector& Ogre::AnimableObject::getAnimableValueNames | ( | void |  | ) | const`[inherited]`

| Gets a list of animable value names for this object. Definition at line 260 of file OgreAnimable.h. References OGRE_EXCEPT.

virtual Real Ogre::Frustum::getAspectRatio | ( | void |  | ) | const`[virtual, inherited]`

| Retreives the current aspect ratio.

bool Ogre::Camera::getAutoAspectRatio | ( | void |  | ) | const

| Retreives if AutoAspectRatio is currently set or not.

const Vector3& Ogre::Camera::getAutoTrackOffset | ( | void |  | ) | const

| Get the auto tracking offset for this camera, if it is auto tracking. Definition at line 479 of file OgreCamera.h.

SceneNode* Ogre::Camera::getAutoTrackTarget | ( | void |  | ) | const

| Get the auto tracking target for this camera, if any. Definition at line 477 of file OgreCamera.h.

const AxisAlignedBox& Ogre::Frustum::getBoundingBox | ( | void |  | ) | const`[virtual, inherited]`

| Overridden from MovableObject. Implements Ogre::MovableObject.

Real Ogre::Camera::getBoundingRadius | ( | void |  | ) | const`[virtual]`

| Overridden from MovableObject. Reimplemented from Ogre::Frustum.

Ray Ogre::Camera::getCameraToViewportRay | ( | Real | screenx,
|  | Real | screeny
| ) | const

  | Gets a world space ray as cast from the camera through a viewport position. Parameters:
  | screenx,screeny | The x and y position at which the ray should intersect the viewport, in normalised screen coordinates [0,1]

bool Ogre::MovableObject::getCastShadows | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether shadow casting is enabled for this object. Implements Ogre::ShadowCaster. Definition at line 442 of file OgreMovableObject.h.

virtual bool Ogre::Renderable::getCastsShadows | ( | void |  | ) | const`[virtual, inherited]`

| Method which reports whether this renderable would normally cast a shadow. Remarks: Subclasses should override this if they could have been used to generate a shadow. Reimplemented in Ogre::InstancedGeometry::GeometryBucket, Ogre::StaticGeometry::GeometryBucket, and Ogre::SubEntity. Definition at line 187 of file OgreRenderable.h.

virtual const PlaneList& Ogre::Renderable::getClipPlanes | ( |  | ) | const`[virtual, inherited]`

| Definition at line 179 of file OgreRenderable.h.

Frustum* Ogre::Camera::getCullingFrustum | ( | void |  | ) |

| Returns the custom culling frustum in use. Definition at line 516 of file OgreCamera.h.

const Vector4& Ogre::Renderable::getCustomParameter | ( | size_t | index | ) | const`[inherited]`

  | Gets the custom value associated with this Renderable at the given index. Parameters:
  | @see | setCustomParaemter for full details.
Definition at line 213 of file OgreRenderable.h. References OGRE_EXCEPT.

const AxisAlignedBox& Ogre::MovableObject::getDarkCapBounds | ( | const Light & | light,
|  | Real | dirLightExtrusionDist
| ) | const`[virtual, inherited]`

| Overridden member from ShadowCaster. Implements Ogre::ShadowCaster.

static uint32 Ogre::MovableObject::getDefaultQueryFlags | ( |  | ) | `[static, inherited]`

| Get the default query flags for all future MovableObject instances. Definition at line 353 of file OgreMovableObject.h.

static uint32 Ogre::MovableObject::getDefaultVisibilityFlags | ( |  | ) | `[static, inherited]`

| Get the default visibility flags for all future MovableObject instances. Definition at line 381 of file OgreMovableObject.h.

Vector3 Ogre::Camera::getDerivedDirection | ( | void |  | ) | const

| Gets the derived direction vector of the camera, including any rotation inherited from a node attachment and reflection matrix.

const Quaternion& Ogre::Camera::getDerivedOrientation | ( | void |  | ) | const

| Gets the derived orientation of the camera, including any rotation inherited from a node attachment and reflection matrix.

const Vector3& Ogre::Camera::getDerivedPosition | ( | void |  | ) | const

| Gets the derived position of the camera, including any translation inherited from a node attachment and reflection matrix.

Vector3 Ogre::Camera::getDerivedRight | ( | void |  | ) | const

| Gets the derived right vector of the camera, including any rotation inherited from a node attachment and reflection matrix.

Vector3 Ogre::Camera::getDerivedUp | ( | void |  | ) | const

| Gets the derived up vector of the camera, including any rotation inherited from a node attachment and reflection matrix.

Vector3 Ogre::Camera::getDirection | ( | void |  | ) | const

EdgeData* Ogre::MovableObject::getEdgeList | ( | void |  | ) | `[virtual, inherited]`

| Define a default implementation of method from ShadowCaster which implements no shadows. Implements Ogre::ShadowCaster. Reimplemented in Ogre::Entity, Ogre::ManualObject, and Ogre::StaticGeometry::Region. Definition at line 415 of file OgreMovableObject.h.

Real Ogre::ShadowCaster::getExtrusionDistance | ( | const Vector3 & | objectPos,
|  | const Light * | light
| ) | const`[protected, inherited]`

| Helper moethod for calculating extrusion distance.

Real Ogre::Camera::getFarClipDistance | ( | void |  | ) | const`[virtual]`

| Reimplemented from Ogre::Frustum.

virtual Real Ogre::Frustum::getFocalLength | ( |  | ) | const`[virtual, inherited]`

| Returns focal length of frustum.

virtual const Radian& Ogre::Frustum::getFOVy | ( | void |  | ) | const`[virtual, inherited]`

| Retrieves the frustums Y-dimension Field Of View (FOV).

virtual const Vector2& Ogre::Frustum::getFrustumOffset | ( |  | ) | const`[virtual, inherited]`

| Retreives the frustum offsets.

const Plane& Ogre::Camera::getFrustumPlane | ( | unsigned short | plane | ) | const`[virtual]`

| Remarks: Gets a reference to one of the planes which make up the frustum frustum, e.g. for clipping purposes. Reimplemented from Ogre::Frustum.

virtual const Plane* Ogre::Frustum::getFrustumPlanes | ( | void |  | ) | const`[virtual, inherited]`

| Retrieves the clipping planes of the frustum (world space). Remarks: The clipping planes are ordered as declared in enumerate constants FrustumPlane.

const AxisAlignedBox& Ogre::MovableObject::getLightCapBounds | ( | void |  | ) | const`[virtual, inherited]`

| Overridden member from ShadowCaster. Implements Ogre::ShadowCaster.

const LightList& Ogre::Frustum::getLights | ( | void |  | ) | const`[virtual, inherited]`

| Overridden from Renderable. Implements Ogre::Renderable.

virtual Listener* Ogre::MovableObject::getListener | ( | void |  | ) | const`[virtual, inherited]`

| Gets the current listener for this object. Definition at line 392 of file OgreMovableObject.h.

Real Ogre::Camera::getLodBias | ( | void |  | ) | const

| Returns the level-of-detail bias factor currently applied to this camera. Remarks: See Camera::setLodBias for more details.

const MaterialPtr& Ogre::Frustum::getMaterial | ( | void |  | ) | const`[virtual, inherited]`

| Overridden from Renderable. Implements Ogre::Renderable.

const String& Ogre::Camera::getMovableType | ( | void |  | ) | const`[virtual]`

| Overridden from MovableObject. Reimplemented from Ogre::Frustum.

virtual const String& Ogre::Camera::getName | ( | void |  | ) | const`[virtual]`

| Gets the camera's name. Reimplemented from Ogre::MovableObject.

Real Ogre::Camera::getNearClipDistance | ( | void |  | ) | const`[virtual]`

| Reimplemented from Ogre::Frustum.

virtual bool Ogre::Renderable::getNormaliseNormals | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether or not this Renderable wishes the hardware to normalise normals. Reimplemented in Ogre::SubEntity. Definition at line 171 of file OgreRenderable.h.

virtual unsigned short Ogre::Renderable::getNumWorldTransforms | ( | void |  | ) | const`[virtual, inherited]`

| Returns the number of world transform matrices this renderable requires. Remarks: When a renderable uses vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity. Reimplemented in Ogre::BorderRenderable, Ogre::InstancedGeometry::GeometryBucket, and Ogre::SubEntity. Definition at line 111 of file OgreRenderable.h.

const Quaternion& Ogre::Camera::getOrientation | ( | void |  | ) | const

| Returns the camera's current orientation.

const Quaternion& Ogre::Camera::getOrientationForViewUpdate | ( | void |  | ) | const`[protected, virtual]`

| Get the derived orientation of this frustum. Reimplemented from Ogre::Frustum.

virtual Node* Ogre::MovableObject::getParentNode | ( | void |  | ) | const`[virtual, inherited]`

| Returns the node to which this object is attached. Remarks: A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. Both are Node subclasses so this method will return either.

virtual SceneNode* Ogre::MovableObject::getParentSceneNode | ( | void |  | ) | const`[virtual, inherited]`

| Returns the scene node to which this object is attached. Remarks: A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. This method will return the scene node of the parent entity if the latter is true.

Real Ogre::MovableObject::getPointExtrusionDistance | ( | const Light * | l | ) | const`[virtual, inherited]`

| Get the distance to extrude for a point/spot light. Implements Ogre::ShadowCaster.

PolygonMode Ogre::Camera::getPolygonMode | ( | void |  | ) | const

| Retrieves the level of detail that the camera will render.

virtual bool Ogre::Renderable::getPolygonModeOverrideable | ( | void |  | ) | const`[virtual, inherited]`

| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. Reimplemented in Ogre::BorderRenderable. Definition at line 277 of file OgreRenderable.h.

const Vector3& Ogre::Camera::getPosition | ( | void |  | ) | const

| Retrieves the camera's position.

const Vector3& Ogre::Camera::getPositionForViewUpdate | ( | void |  | ) | const`[protected, virtual]`

| Get the derived position of this frustum. Reimplemented from Ogre::Frustum.

virtual const Matrix4& Ogre::Frustum::getProjectionMatrix | ( | void |  | ) | const`[virtual, inherited]`

| Gets the normal projection matrix for this frustum, ie the projection matrix which conforms to standard right-handed rules and uses depth range [-1,+1]. Remarks: This differs from the rendering-API dependent getProjectionMatrixRS in that it always returns a right-handed projection matrix with depth range [-1,+1], result no matter what rendering API is being used - this is required for some uniform algebra for example.

virtual const Matrix4& Ogre::Frustum::getProjectionMatrixRS | ( | void |  | ) | const`[virtual, inherited]`

| Gets the projection matrix for this frustum adjusted for the current rendersystem specifics (may be right or left-handed, depth range may vary). Remarks: This method retrieves the rendering-API dependent version of the projection matrix. If you want a 'typical' projection matrix then use getProjectionMatrix.

virtual const Matrix4& Ogre::Frustum::getProjectionMatrixWithRSDepth | ( | void |  | ) | const`[virtual, inherited]`

| Gets the depth-adjusted projection matrix for the current rendersystem, but one which still conforms to right-hand rules. Remarks: This differs from the rendering-API dependent getProjectionMatrix in that it always returns a right-handed projection matrix result no matter what rendering API is being used - this is required for vertex and fragment programs for example. However, the resulting depth range may still vary between render systems since D3D uses [0,1] and GL uses [-1,1], and the range must be kept the same between programmable and fixed-function pipelines.

virtual ProjectionType Ogre::Frustum::getProjectionType | ( | void |  | ) | const`[virtual, inherited]`

| Retrieves info on the type of projection used (orthographic or perspective).

virtual uint32 Ogre::MovableObject::getQueryFlags | ( | void |  | ) | const`[virtual, inherited]`

| Returns the query flags relevant for this object. Definition at line 345 of file OgreMovableObject.h.

virtual std::vector<Vector4> Ogre::Camera::getRayForwardIntersect | ( | const Vector3 & | anchor,
|  | const Vector3 * | dir,
|  | Real | planeOffset
| ) | const`[protected, virtual]`

| Helper function for forwardIntersect that intersects rays with canonical plane.

Vector3 Ogre::Camera::getRealDirection | ( | void |  | ) | const

| Gets the real world direction vector of the camera, including any rotation inherited from a node attachment.

const Quaternion& Ogre::Camera::getRealOrientation | ( | void |  | ) | const

| Gets the real world orientation of the camera, including any rotation inherited from a node attachment.

const Vector3& Ogre::Camera::getRealPosition | ( | void |  | ) | const

| Gets the real world position of the camera, including any translation inherited from a node attachment.

Vector3 Ogre::Camera::getRealRight | ( | void |  | ) | const

| Gets the real world right vector of the camera, including any rotation inherited from a node attachment.

Vector3 Ogre::Camera::getRealUp | ( | void |  | ) | const

| Gets the real world up vector of the camera, including any rotation inherited from a node attachment.

virtual const Matrix4& Ogre::Frustum::getReflectionMatrix | ( | void |  | ) | const`[virtual, inherited]`

| Returns the reflection matrix of the frustum if appropriate. Definition at line 512 of file OgreFrustum.h.

virtual const Plane& Ogre::Frustum::getReflectionPlane | ( | void |  | ) | const`[virtual, inherited]`

| Returns the reflection plane of the frustum if appropriate. Definition at line 514 of file OgreFrustum.h.

virtual Real Ogre::MovableObject::getRenderingDistance | ( | void |  | ) | const`[virtual, inherited]`

| Gets the distance at which batches are no longer rendered. Definition at line 278 of file OgreMovableObject.h.

void Ogre::Frustum::getRenderOperation | ( | RenderOperation & | op | ) | `[virtual, inherited]`

| Overridden from Renderable. Implements Ogre::Renderable.

virtual uint8 Ogre::MovableObject::getRenderQueueGroup | ( | void |  | ) | const`[virtual, inherited]`

| Gets the queue group for this entity, see setRenderQueueGroup for full details.

Vector3 Ogre::Camera::getRight | ( | void |  | ) | const

| Gets the camera's right vector.

SceneManager* Ogre::Camera::getSceneManager | ( | void |  | ) | const

| Returns a pointer to the SceneManager this camera is rendering through.

ShadowRenderableListIterator Ogre::MovableObject::getShadowVolumeRenderableIterator | ( | ShadowTechnique | shadowTechnique,
|  | const Light * | light,
|  | HardwareIndexBufferSharedPtr * | indexBuffer,
|  | bool | extrudeVertices,
|  | Real | extrusionDist,
|  | unsigned long | flags = `0`
| ) | `[virtual, inherited]`

| Define a default implementation of method from ShadowCaster which implements no shadows. Implements Ogre::ShadowCaster. Reimplemented in Ogre::Entity, Ogre::ManualObject, and Ogre::StaticGeometry::Region.

Real Ogre::Frustum::getSquaredViewDepth | ( | const Camera * | cam | ) | const`[virtual, inherited]`

| Overridden from Renderable. Implements Ogre::Renderable.

virtual Technique* Ogre::Renderable::getTechnique | ( | void |  | ) | const`[virtual, inherited]`

| Retrieves a pointer to the Material Technique this renderable object uses. Remarks: This is to allow Renderables to use a chosen Technique if they wish, otherwise they will use the best Technique available for the Material they are using. Reimplemented in Ogre::InstancedGeometry::GeometryBucket, Ogre::StaticGeometry::GeometryBucket, and Ogre::SubEntity. Definition at line 73 of file OgreRenderable.h.

virtual uint32 Ogre::MovableObject::getTypeFlags | ( | void |  | ) | const`[virtual, inherited]`

| Get the 'type flags' for this MovableObject. Remarks: A type flag identifies the type of the MovableObject as a bitpattern. This is used for categorical inclusion / exclusion in SceneQuery objects. By default, this method returns all ones for objects not created by a MovableObjectFactory (hence always including them); otherwise it returns the value assigned to the MovableObjectFactory. Custom objects which don't use MovableObjectFactory will need to override this if they want to be included in queries. Reimplemented in Ogre::BillboardSet, Ogre::Entity, Ogre::Light, Ogre::ParticleSystem, and Ogre::StaticGeometry::Region.

Vector3 Ogre::Camera::getUp | ( | void |  | ) | const

| Gets the camera's up vector.

bool Ogre::Renderable::getUseIdentityProjection | ( | void |  | ) | const`[inherited]`

| Returns whether or not to use an 'identity' projection. Remarks: Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. See also: Renderable::setUseIdentityProjection Definition at line 136 of file OgreRenderable.h.

bool Ogre::Renderable::getUseIdentityView | ( | void |  | ) | const`[inherited]`

| Returns whether or not to use an 'identity' view. Remarks: Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. See also: Renderable::setUseIdentityView Definition at line 161 of file OgreRenderable.h.

virtual const Any& Ogre::MovableObject::getUserAny | ( | void |  | ) | const`[virtual, inherited]`

| Retrieves the custom user value associated with this object. Definition at line 306 of file OgreMovableObject.h.

virtual bool Ogre::Camera::getUseRenderingDistance | ( | void |  | ) | const`[virtual]`

| Get whether this camera should use the 'rendering distance' on objects to exclude distant objects from the final image. Definition at line 561 of file OgreCamera.h.

virtual UserDefinedObject* Ogre::MovableObject::getUserObject | ( | void |  | ) | `[virtual, inherited]`

| Retrieves a pointer to a custom application object associated with this movable by an earlier call to setUserObject. Definition at line 290 of file OgreMovableObject.h.

const Matrix4& Ogre::Camera::getViewMatrix | ( | bool | ownFrustumOnly | ) | const

| Specialised version of getViewMatrix allowing caller to differentiate whether the custom culling frustum should be allowed or not. Remarks: The default behaviour of the standard getViewMatrix is to delegate to the alternate culling frustum, if it is set. This is expected when performing CPU calculations, but the final rendering must be performed using the real view matrix in order to display the correct debug view.

const Matrix4& Ogre::Camera::getViewMatrix | ( | void |  | ) | const`[virtual]`

| Mainly for use by OGRE internally. Reimplemented from Ogre::Frustum.

Viewport* Ogre::Camera::getViewport | ( | void |  | ) | const

| Get the last viewport which was attached to this camera. Note: This is not guaranteed to be the only viewport which is using this camera, just the last once which was created referring to it. Definition at line 486 of file OgreCamera.h.

virtual uint32 Ogre::MovableObject::getVisibilityFlags | ( | void |  | ) | const`[virtual, inherited]`

| Returns the visibility flags relevant for this object. Definition at line 373 of file OgreMovableObject.h.

virtual bool Ogre::MovableObject::getVisible | ( | void |  | ) | const`[virtual, inherited]`

| Gets this object whether to be visible or not, if it has a renderable component. Remarks: Returns the value set by MovableObject::setVisible only.

const std::vector<Plane>& Ogre::Camera::getWindowPlanes | ( | void |  | ) | const

| Gets the window clip planes, only applicable if isWindowSet == true.

virtual const AxisAlignedBox& Ogre::MovableObject::getWorldBoundingBox | ( | bool | derive = `false` | ) | const`[virtual, inherited]`

| Retrieves the axis-aligned bounding box for this object in world coordinates. Implements Ogre::ShadowCaster. Reimplemented in Ogre::Entity.

virtual const Sphere& Ogre::MovableObject::getWorldBoundingSphere | ( | bool | derive = `false` | ) | const`[virtual, inherited]`

| Retrieves the worldspace bounding sphere for this object. Reimplemented in Ogre::Entity.

const Quaternion& Ogre::Frustum::getWorldOrientation | ( | void |  | ) | const`[virtual, inherited]`

| Overridden from Renderable. Implements Ogre::Renderable.

const Vector3& Ogre::Frustum::getWorldPosition | ( | void |  | ) | const`[virtual, inherited]`

| Overridden from Renderable. Implements Ogre::Renderable.

const Vector3* Ogre::Camera::getWorldSpaceCorners | ( | void |  | ) | const`[virtual]`

| Remarks: The corners are ordered as follows: top-right near, top-left near, bottom-left near, bottom-right near, top-right far, top-left far, bottom-left far, bottom-right far. Reimplemented from Ogre::Frustum.

void Ogre::Frustum::getWorldTransforms | ( | Matrix4 * | xform | ) | const`[virtual, inherited]`

| Overridden from Renderable. Implements Ogre::Renderable.

bool Ogre::MovableObject::hasEdgeList | ( | void |  | ) | `[virtual, inherited]`

| Define a default implementation of method from ShadowCaster which implements no shadows. Implements Ogre::ShadowCaster. Reimplemented in Ogre::Entity, Ogre::ManualObject, and Ogre::StaticGeometry::Region. Definition at line 417 of file OgreMovableObject.h.

virtual void Ogre::AnimableObject::initialiseAnimableDictionary | ( | StringVector & |  | ) | const`[protected, virtual, inherited]`

| Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters. Reimplemented in Ogre::Light. Definition at line 252 of file OgreAnimable.h.

void Ogre::Camera::invalidateFrustum | ( | void |  | ) | const`[protected, virtual]`

| Signal to update frustum information. Reimplemented from Ogre::Frustum.

void Ogre::Camera::invalidateView | ( | void |  | ) | const`[protected, virtual]`

| Signal to update view information. Reimplemented from Ogre::Frustum.

virtual bool Ogre::MovableObject::isAttached | ( | void |  | ) | const`[virtual, inherited]`

| Returns true if this object is attached to a SceneNode or TagPoint.

virtual bool Ogre::Frustum::isCustomNearClipPlaneEnabled | ( | void |  | ) | const`[virtual, inherited]`

| Is a custom near clip plane in use? Definition at line 579 of file OgreFrustum.h.

virtual bool Ogre::Frustum::isCustomProjectionMatrixEnabled | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether a custom projection matrix is in use. Definition at line 383 of file OgreFrustum.h.

virtual bool Ogre::Frustum::isCustomViewMatrixEnabled | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether a custom view matrix is in use. Definition at line 358 of file OgreFrustum.h.

virtual bool Ogre::Frustum::isFrustumOutOfDate | ( | void |  | ) | const`[protected, virtual, inherited]`

virtual bool Ogre::MovableObject::isInScene | ( | void |  | ) | const`[virtual, inherited]`

| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.

virtual bool Ogre::Frustum::isReflected | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether this frustum is being reflected. Definition at line 510 of file OgreFrustum.h.

bool Ogre::Camera::isViewOutOfDate | ( | void |  | ) | const`[protected, virtual]`

| Reimplemented from Ogre::Frustum.

virtual bool Ogre::MovableObject::isVisible | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether or not this object is supposed to be visible or not. Remarks: Takes into account both upper rendering distance and visible flag. Reimplemented in Ogre::InstancedGeometry::BatchInstance, and Ogre::StaticGeometry::Region.

bool Ogre::Camera::isVisible | ( | const Vector3 & | vert,
|  | FrustumPlane * | culledBy = `0`
| ) | const`[virtual]`

  | Parameters:
  | bound | Bounding box to be checked (world space)
  | culledBy | Optional pointer to an int which will be filled by the plane number which culled the box if the result was false;
Returns: If the box was visible, true is returned. Otherwise, false is returned. Reimplemented from Ogre::Frustum.

bool Ogre::Camera::isVisible | ( | const Sphere & | bound,
|  | FrustumPlane * | culledBy = `0`
| ) | const`[virtual]`

  | Parameters:
  | bound | Bounding box to be checked (world space)
  | culledBy | Optional pointer to an int which will be filled by the plane number which culled the box if the result was false;
Returns: If the box was visible, true is returned. Otherwise, false is returned. Reimplemented from Ogre::Frustum.

bool Ogre::Camera::isVisible | ( | const AxisAlignedBox & | bound,
|  | FrustumPlane * | culledBy = `0`
| ) | const`[virtual]`

  | Parameters:
  | bound | Bounding box to be checked (world space)
  | culledBy | Optional pointer to an int which will be filled by the plane number which culled the box if the result was false;
Returns: If the box was visible, true is returned. Otherwise, false is returned. Reimplemented from Ogre::Frustum.

virtual bool Ogre::Camera::isWindowSet | ( | void |  | ) | const`[virtual]`

| Returns if a viewport window is being used. Definition at line 470 of file OgreCamera.h.

void Ogre::Camera::lookAt | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) |

  | Points the camera at a location in worldspace. Remarks: This is a helper method to automatically generate the direction vector for the camera, based on it's current position and the supplied look-at point. Parameters:
  | x |
  | y |
  | z | Co-ordinates of the point to look at.

void Ogre::Camera::lookAt | ( | const Vector3 & | targetPoint | ) |

  | Points the camera at a location in worldspace. Remarks: This is a helper method to automatically generate the direction vector for the camera, based on it's current position and the supplied look-at point. Parameters:
  | targetPoint | A vector specifying the look at point.

void Ogre::Camera::move | ( | const Vector3 & | vec | ) |

| Moves the camera's position by the vector offset provided along world axes.

void Ogre::Camera::moveRelative | ( | const Vector3 & | vec | ) |

| Moves the camera's position by the vector offset provided along it's own axes (relative to orientation).

void Ogre::Camera::pitch | ( | const Radian & | angle | ) |

| Pitches the camera up/down anticlockwise around it's local z axis.

bool Ogre::Camera::projectSphere | ( | const Sphere & | sphere,
|  | Real * | left,
|  | Real * | top,
|  | Real * | right,
|  | Real * | bottom
| ) | const`[virtual]`

  | Parameters:
  | sphere | The world-space sphere to project
  | radius | Radius of the sphere
  | left,top,right,bottom | Pointers to destination values, these will be completed with the normalised device coordinates (in the range {-1,1})
Returns: true if the sphere was projected to a subset of the near plane, false if the entire near plane was contained Reimplemented from Ogre::Frustum.

virtual const LightList& Ogre::MovableObject::queryLights | ( | void |  | ) | const`[virtual, inherited]`

| Gets a list of lights, ordered relative to how close they are to this movable object. Remarks: By default, this method gives the listener a chance to populate light list first, if there is no listener or Listener::objectQueryLights returns NULL, it'll query the light list from parent entity if it is present, or returns SceneNode::findLights if it has parent scene node, otherwise it just returns an empty list. The object internally caches the light list, so it will recalculate it only when object is moved, or lights that affect the frustum have been changed ( See also: SceneManager::_getLightsDirtyCounter), but if listener exists, it will be called each time, so the listener should implement their own cache mechanism to optimise performance. This method can be useful when implementing Renderable::getLights in case the renderable is a part of the movable. Returns: The list of lights use to lighting this object.

virtual void Ogre::MovableObject::removeQueryFlags | ( | unsigned long | flags | ) | `[virtual, inherited]`

| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object. Definition at line 342 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::removeVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object. Definition at line 370 of file OgreMovableObject.h.

virtual void Ogre::Camera::resetWindow | ( | void |  | ) | `[virtual]`

| Cancel view window.

void Ogre::Camera::roll | ( | const Radian & | angle | ) |

| Rolls the camera anticlockwise, around its local z axis.

void Ogre::Camera::rotate | ( | const Quaternion & | q | ) |

| Rotate the camera around an aritrary axis using a Quarternion.

void Ogre::Camera::rotate | ( | const Vector3 & | axis,
|  | const Radian & | angle
| ) |

| Rotate the camera around an arbitrary axis.

virtual void Ogre::Frustum::setAspectRatio | ( | Real | ratio | ) | `[virtual, inherited]`

| Sets the aspect ratio for the frustum viewport. Remarks: The ratio between the x and y dimensions of the rectangular area visible through the frustum is known as aspect ratio: aspect = width / height . The default for most fullscreen windows is 1.3333 - this is also assumed by Ogre unless you use this method to state otherwise.

void Ogre::Camera::setAutoAspectRatio | ( | bool | autoratio | ) |

| If set to true a vieport that owns this frustum will be able to recalculate the aspect ratio whenever the frustum is resized. Remarks: You should set this to true only if the frustum / camera is used by one viewport at the same time. Otherwise the aspect ratio for other viewports may be wrong.

void Ogre::Camera::setAutoTracking | ( | bool | enabled,
|  | SceneNode * | target = `0`,
|  | const Vector3 & | offset = `Vector3::ZERO`
| ) |

  | Enables / disables automatic tracking of a SceneNode. Remarks: If you enable auto-tracking, this Camera will automatically rotate to look at the target SceneNode every frame, no matter how it or SceneNode move. This is handy if you want a Camera to be focused on a single object or group of objects. Note that by default the Camera looks at the origin of the SceneNode, if you want to tweak this, e.g. if the object which is attached to this target node is quite big and you want to point the camera at a specific point on it, provide a vector in the 'offset' parameter and the camera's target point will be adjusted. Parameters:
  | enabled | If true, the Camera will track the SceneNode supplied as the next parameter (cannot be null). If false the camera will cease tracking and will remain in it's current orientation.
  | target | Pointer to the SceneNode which this Camera will track. Make sure you don't delete this SceneNode before turning off tracking (e.g. SceneManager::clearScene will delete it so be careful of this). Can be null if and only if the enabled param is false.
  | offset | If supplied, the camera targets this point in local space of the target node instead of the origin of the target node. Good for fine tuning the look at point.

void Ogre::MovableObject::setCastShadows | ( | bool | enabled | ) | `[inherited]`

| Sets whether or not this object will cast shadows. Remarks: This setting simply allows you to turn on/off shadows for a given object. An object will not cast shadows unless the scene supports it in any case (see SceneManager::setShadowTechnique), and also the material which is in use must also have shadow casting enabled. By default all entities cast shadows. If, however, for some reason you wish to disable this for a single object then you can do so using this method. Note: This method normally refers to objects which block the light, but since Light is also a subclass of MovableObject, in that context it means whether the light causes shadows itself. Definition at line 440 of file OgreMovableObject.h.

void Ogre::Camera::setCullingFrustum | ( | Frustum * | frustum | ) |

  | Tells the camera to use a separate Frustum instance to perform culling. Remarks: By calling this method, you can tell the camera to perform culling against a different frustum to it's own. This is mostly useful for debug cameras that allow you to show the culling behaviour of another camera, or a manual frustum instance. Parameters:
  | frustum | Pointer to a frustum to use; this can either be a manual Frustum instance (which you can attach to scene nodes like any other MovableObject), or another camera. If you pass 0 to this method it reverts the camera to normal behaviour.
Definition at line 514 of file OgreCamera.h.

void Ogre::Renderable::setCustomParameter | ( | size_t | index,
|  | const Vector4 & | value
| ) | `[inherited]`

  | Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters. Remarks: Calling this method simply associates a numeric index with a 4-dimensional value for this specific Renderable. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter. Parameters:
  | index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_CUSTOM entry, if that is used.
  | value | The value to associate.
Definition at line 204 of file OgreRenderable.h.

virtual void Ogre::Frustum::setCustomProjectionMatrix | ( | bool | enable,
|  | const Matrix4 & | projectionMatrix = `Matrix4::IDENTITY`
| ) | `[virtual, inherited]`

  | Set whether to use a custom projection matrix on this frustum. Remarks: This is an advanced method which allows you to manually set the projection matrix on this frustum, rather than having it calculate itself based on it's position and orientation. Note: After enabling a custom projection matrix, the frustum will no longer update on its own based on field of view and near / far distance changes. You are completely responsible for keeping the projection matrix up to date if those values change. The custom matrix will be returned from getProjectionMatrix and derivative functions. Parameters:
  | enable | If true, the custom projection matrix passed as the second parameter will be used in preference to an auto calculated one. If false, the frustum will revert to auto calculating the projection matrix.
  | projectionMatrix | The custom view matrix to use
See also: Frustum::setCustomViewMatrix

virtual void Ogre::Frustum::setCustomViewMatrix | ( | bool | enable,
|  | const Matrix4 & | viewMatrix = `Matrix4::IDENTITY`
| ) | `[virtual, inherited]`

  | Set whether to use a custom view matrix on this frustum. Remarks: This is an advanced method which allows you to manually set the view matrix on this frustum, rather than having it calculate itself based on it's position and orientation. Note: After enabling a custom view matrix, the frustum will no longer update on its own based on position / orientation changes. You are completely responsible for keeping the view matrix up to date. The custom matrix will be returned from getViewMatrix. Parameters:
  | enable | If true, the custom view matrix passed as the second parameter will be used in preference to an auto calculated one. If false, the frustum will revert to auto calculating the view matrix.
  | viewMatrix | The custom view matrix to use, the matrix must be an affine matrix.
See also: Frustum::setCustomProjectionMatrix, Matrix4::isAffine

static void Ogre::MovableObject::setDefaultQueryFlags | ( | uint32 | flags | ) | `[static, inherited]`

| Set the default query flags for all future MovableObject instances. Definition at line 349 of file OgreMovableObject.h.

static void Ogre::MovableObject::setDefaultVisibilityFlags | ( | uint32 | flags | ) | `[static, inherited]`

| Set the default visibility flags for all future MovableObject instances. Definition at line 377 of file OgreMovableObject.h.

void Ogre::Camera::setDirection | ( | const Vector3 & | vec | ) |

| Sets the camera's direction vector.

void Ogre::Camera::setDirection | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) |

| Sets the camera's direction vector. Remarks: Note that the 'up' vector for the camera will automatically be recalculated based on the current 'up' vector (i.e. the roll will remain the same).

virtual void Ogre::Frustum::setFarClipDistance | ( | Real | farDist | ) | `[virtual, inherited]`

  | Sets the distance to the far clipping plane. Remarks: The view frustrum is a pyramid created from the frustum position and the edges of the viewport. This method sets the distance for the far end of that pyramid. Different applications need different values: e.g. a flight sim needs a much further far clipping plane than a first-person shooter. An important point here is that the larger the ratio between near and far clipping planes, the lower the accuracy of the Z-buffer used to depth-cue pixels. This is because the Z-range is limited to the size of the Z buffer (16 or 32-bit) and the max values must be spread over the gap between near and far clip planes. As it happens, you can affect the accuracy far more by altering the near distance rather than the far distance, but keep this in mind. Parameters:
  | far | The distance to the far clipping plane from the frustum in world coordinates.If you specify 0, this means an infinite view distance which is useful especially when projecting shadows; but be careful not to use a near distance too close.

void Ogre::Camera::setFixedYawAxis | ( | bool | useFixed,
|  | const Vector3 & | fixedAxis = `Vector3::UNIT_Y`
| ) |

  | Tells the camera whether to yaw around it's own local Y axis or a fixed axis of choice. Remarks: This method allows you to change the yaw behaviour of the camera by default, the camera yaws around a fixed Y axis. This is often what you want - for example if you're making a first-person shooter, you really don't want the yaw axis to reflect the local camera Y, because this would mean a different yaw axis if the player is looking upwards rather than when they are looking straight ahead. You can change this behaviour by calling this method, which you will want to do if you are making a completely free camera like the kind used in a flight simulator. Parameters:
  | useFixed | If true, the axis passed in the second parameter will always be the yaw axis no matter what the camera orientation. If false, the camera yaws around the local Y.
  | fixedAxis | The axis to use if the first parameter is true.

virtual void Ogre::Frustum::setFocalLength | ( | Real | focalLength = `1.0` | ) | `[virtual, inherited]`

  | Sets frustum focal length (used in stereo rendering). Parameters:
  | focalLength | The distance to the focal plane from the frustum in world coordinates.

virtual void Ogre::Frustum::setFOVy | ( | const Radian & | fovy | ) | `[virtual, inherited]`

| Sets the Y-dimension Field Of View (FOV) of the frustum. Remarks: Field Of View (FOV) is the angle made between the frustum's position, and the edges of the 'screen' onto which the scene is projected. High values (90+ degrees) result in a wide-angle, fish-eye kind of view, low values (30- degrees) in a stretched, telescopic kind of view. Typical values are between 45 and 60 degrees. This value represents the VERTICAL field-of-view. The horizontal field of view is calculated from this depending on the dimensions of the viewport (they will only be the same if the viewport is square). Note: Setting the FOV overrides the value supplied for frustum::setNearClipPlane.

virtual void Ogre::Frustum::setFrustumOffset | ( | Real | horizontal = `0.0`,
|  | Real | vertical = `0.0`
| ) | `[virtual, inherited]`

  | Sets frustum offsets, used in stereo rendering. Remarks: You can set both horizontal and vertical plane offsets of "eye"; in stereo rendering frustum is moved in horizontal plane. To be able to render from two "eyes" you'll need two cameras rendering on two RenderTargets. The frustum offsets is in world coordinates, and default to (0, 0) - no offsets. Parameters:
  | horizontal | The horizontal plane offset.
  | vertical | The vertical plane offset.

virtual void Ogre::Frustum::setFrustumOffset | ( | const Vector2 & | offset | ) | `[virtual, inherited]`

  | Sets frustum offsets, used in stereo rendering. Remarks: You can set both horizontal and vertical plane offsets of "eye"; in stereo rendering frustum is moved in horizontal plane. To be able to render from two "eyes" you'll need two cameras rendering on two RenderTargets. The frustum offsets is in world coordinates, and default to (0, 0) - no offsets. Parameters:
  | offset | The horizontal and vertical plane offsets.

virtual void Ogre::MovableObject::setListener | ( | Listener * | listener | ) | `[virtual, inherited]`

| Sets a listener for this object. Remarks: Note for size and performance reasons only one listener per object is allowed. Definition at line 388 of file OgreMovableObject.h.

void Ogre::Camera::setLodBias | ( | Real | factor = `1.0` | ) |

  | Sets the level-of-detail factor for this Camera. Remarks: This method can be used to influence the overall level of detail of the scenes rendered using this camera. Various elements of the scene have level-of-detail reductions to improve rendering speed at distance; this method allows you to hint to those elements that you would like to adjust the level of detail that they would normally use (up or down). The most common use for this method is to reduce the overall level of detail used for a secondary camera used for sub viewports like rear-view mirrors etc. Note that scene elements are at liberty to ignore this setting if they choose, this is merely a hint. Parameters:
  | factor | The factor to apply to the usual level of detail calculation. Higher values increase the detail, so 2.0 doubles the normal detail and 0.5 halves it.

virtual void Ogre::Frustum::setNearClipDistance | ( | Real | nearDist | ) | `[virtual, inherited]`

  | Sets the position of the near clipping plane. Remarks: The position of the near clipping plane is the distance from the frustums position to the screen on which the world is projected. The near plane distance, combined with the field-of-view and the aspect ratio, determines the size of the viewport through which the world is viewed (in world co-ordinates). Note that this world viewport is different to a screen viewport, which has it's dimensions expressed in pixels. The frustums viewport should have the same aspect ratio as the screen viewport it renders into to avoid distortion. Parameters:
  | near | The distance to the near clipping plane from the frustum in world coordinates.

void Ogre::Camera::setOrientation | ( | const Quaternion & | q | ) |

| Sets the camera's orientation.

void Ogre::Camera::setPolygonMode | ( | PolygonMode | sd | ) |

| Sets the level of rendering detail required from this camera. Remarks: Each camera is set to render at full detail by default, that is with full texturing, lighting etc. This method lets you change that behaviour, allowing you to make the camera just render a wireframe view, for example.

virtual void Ogre::Renderable::setPolygonModeOverrideable | ( | bool | override | ) | `[virtual, inherited]`

  | Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. Parameters:
  | override | true means that a lower camera detail will override this renderables detail level, false means it won't.
Definition at line 269 of file OgreRenderable.h.

void Ogre::Camera::setPosition | ( | const Vector3 & | vec | ) |

| Sets the camera's position.

void Ogre::Camera::setPosition | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) |

| Sets the camera's position.

virtual void Ogre::Frustum::setProjectionType | ( | ProjectionType | pt | ) | `[virtual, inherited]`

| Sets the type of projection to use (orthographic or perspective). Default is perspective.

virtual void Ogre::MovableObject::setQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

| Sets the query flags for this object. Remarks: When performing a scene query, this object will be included or excluded according to flags on the object and flags on the query. This is a bitwise value, so only when a bit on these flags is set, will it be included in a query asking for that flag. The meaning of the bits is application-specific. Definition at line 334 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setRenderingDistance | ( | Real | dist | ) | `[virtual, inherited]`

  | Sets the distance at which the object is no longer rendered. Parameters:
  | dist | Distance beyond which the object will not be rendered (the default is 0, which means objects are always rendered).
Definition at line 272 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setRenderQueueGroup | ( | uint8 | queueID | ) | `[virtual, inherited]`

  | Sets the render queue group this entity will be rendered through. Remarks: Render queues are grouped to allow you to more tightly control the ordering of rendered objects. If you do not call this method, all Entity objects default to the default queue (RenderQueue::getDefaultQueueGroup), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such. See RenderQueue for more details. Parameters:
  | queueID | Enumerated value of the queue group to use.
Reimplemented in Ogre::Entity, and Ogre::ParticleSystem.

void Ogre::Renderable::setUseIdentityProjection | ( | bool | useIdentityProjection | ) | `[inherited]`

| Sets whether or not to use an 'identity' projection. Remarks: Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. The default is false. See also: Renderable::getUseIdentityProjection Definition at line 122 of file OgreRenderable.h.

void Ogre::Renderable::setUseIdentityView | ( | bool | useIdentityView | ) | `[inherited]`

| Sets whether or not to use an 'identity' view. Remarks: Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. The default is false. See also: Renderable::getUseIdentityView Definition at line 147 of file OgreRenderable.h.

virtual void Ogre::MovableObject::setUserAny | ( | const Any & | anything | ) | `[virtual, inherited]`

| Sets any kind of user value on this object. Remarks: This method allows you to associate any user value you like with this MovableObject. This can be a pointer back to one of your own classes for instance. Note: This value is shared with setUserObject so don't use both! Definition at line 302 of file OgreMovableObject.h.

virtual void Ogre::Camera::setUseRenderingDistance | ( | bool | use | ) | `[virtual]`

  | Set whether this camera should use the 'rendering distance' on objects to exclude distant objects from the final image. The default behaviour is to use it. Parameters:
  | use | True to use the rendering distance, false not to.
Definition at line 557 of file OgreCamera.h.

virtual void Ogre::MovableObject::setUserObject | ( | UserDefinedObject * | obj | ) | `[virtual, inherited]`

| Call this to associate your own custom user object instance with this MovableObject. Remarks: By simply making your game / application object a subclass of UserDefinedObject, you can establish a link between an OGRE instance of MovableObject and your own application classes. Call this method to establish the link. Definition at line 286 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

| Sets the visiblity flags for this object. Remarks: As well as a simple true/false value for visibility (as seen in setVisible), you can also set visiblity flags which when 'and'ed with the SceneManager's visibility mask can also make an object invisible. Definition at line 362 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setVisible | ( | bool | visible | ) | `[virtual, inherited]`

| Tells this object whether to be visible or not, if it has a renderable component. Note: An alternative approach of making an object invisible is to detach it from it's SceneNode, or to remove the SceneNode entirely. Detaching a node means that structurally the scene graph changes. Once this change has taken place, the objects / nodes that have been removed have less overhead to the visbility detection pass than simply making the object invisible, so if you do this and leave the objects out of the tree for a long time, it's faster. However, the act of detaching / reattaching nodes is in itself more expensive than setting an object visibility flag, since in the latter case structural changes are not made. Therefore, small or frequent visbility changes are best done using this method; large or more longer term changes are best done by detaching. Reimplemented in Ogre::Light.

virtual void Ogre::Camera::setWindow | ( | Real | Left,
|  | Real | Top,
|  | Real | Right,
|  | Real | Bottom
| ) | `[virtual]`

  | Sets the viewing window inside of viewport. Remarks: This method can be used to set a subset of the viewport as the rendering target. Parameters:
  | Left | Relative to Viewport - 0 corresponds to left edge, 1 - to right edge (default - 0).
  | Top | Relative to Viewport - 0 corresponds to top edge, 1 - to bottom edge (default - 0).
  | Right | Relative to Viewport - 0 corresponds to left edge, 1 - to right edge (default - 1).
  | Bottom | Relative to Viewport - 0 corresponds to top edge, 1 - to bottom edge (default - 1).

virtual void Ogre::Camera::setWindowImpl | ( | void |  | ) | const`[protected, virtual]`

| Do actual window setting, using parameters set in SetWindow call. Remarks: The method will called on demand.

virtual void Ogre::ShadowCaster::updateEdgeListLightFacing | ( | EdgeData * | edgeData,
|  | const Vector4 & | lightPos
| ) | `[protected, virtual, inherited]`

  | Tells the caster to perform the tasks necessary to update the edge data's light listing. Can be overridden if the subclass needs to do additional things. Parameters:
  | edgeData | The edge information to update
  | lightPos | 4D vector representing the light, a directional light has w=0.0

virtual void Ogre::Frustum::updateFrustum | ( | void |  | ) | const`[protected, virtual, inherited]`

| Update frustum if out of date.

virtual void Ogre::Frustum::updateFrustumImpl | ( | void |  | ) | const`[protected, virtual, inherited]`

| Implementation of updateFrustum (called if out of date).

virtual void Ogre::Frustum::updateFrustumPlanes | ( | void |  | ) | const`[protected, virtual, inherited]`

virtual void Ogre::Frustum::updateFrustumPlanesImpl | ( | void |  | ) | const`[protected, virtual, inherited]`

| Implementation of updateFrustumPlanes (called if out of date).

virtual void Ogre::Frustum::updateVertexData | ( | void |  | ) | const`[protected, virtual, inherited]`

virtual void Ogre::Frustum::updateView | ( | void |  | ) | const`[protected, virtual, inherited]`

| Update view if out of date.

virtual void Ogre::Frustum::updateViewImpl | ( | void |  | ) | const`[protected, virtual, inherited]`

| Implementation of updateView (called if out of date).

virtual void Ogre::Frustum::updateWorldSpaceCorners | ( | void |  | ) | const`[protected, virtual, inherited]`

virtual void Ogre::Frustum::updateWorldSpaceCornersImpl | ( | void |  | ) | const`[protected, virtual, inherited]`

| Implementation of updateWorldSpaceCorners (called if out of date).

void Ogre::Camera::yaw | ( | const Radian & | angle | ) |

| Rotates the camera anticlockwise around it's local y axis.

## Friends And Related Function Documentation

_OgreExport friend std::ostream& operator<< | ( | std::ostream & | o,
|  | const Camera & | c
| ) | `[friend]`

| Function for outputting to a stream.

## Member Data Documentation

const Real Ogre::Frustum::INFINITE_FAR_PLANE_ADJUST`[static, inherited]`

| Small constant used to reduce far plane projection to avoid inaccuracies. Definition at line 584 of file OgreFrustum.h.

Real Ogre::Frustum::mAspect`[protected, inherited]`

| x/y viewport ratio - default 1.3333 Definition at line 78 of file OgreFrustum.h.

bool Ogre::Camera::mAutoAspectRatio`[protected]`

| Whether aspect ratio will automaticaally be recalculated when a vieport changes its size. Definition at line 146 of file OgreCamera.h.

Vector3 Ogre::Camera::mAutoTrackOffset`[protected]`

| Tracking offset for fine tuning. Definition at line 122 of file OgreCamera.h.

SceneNode* Ogre::Camera::mAutoTrackTarget`[protected]`

| SceneNode which this Camera will automatically track. Definition at line 120 of file OgreCamera.h.

bool Ogre::MovableObject::mBeyondFarDistance`[protected, inherited]`

| Hidden because of distance? Definition at line 115 of file OgreMovableObject.h.

AxisAlignedBox Ogre::Frustum::mBoundingBox`[mutable, protected, inherited]`

| Definition at line 142 of file OgreFrustum.h.

bool Ogre::MovableObject::mCastShadows`[protected, inherited]`

| Does this object cast shadows? Definition at line 133 of file OgreMovableObject.h.

MovableObjectFactory* Ogre::MovableObject::mCreator`[protected, inherited]`

| Creator of this object (if created by a factory). Definition at line 103 of file OgreMovableObject.h.

Frustum* Ogre::Camera::mCullFrustum`[protected]`

| Custom culling frustum. Definition at line 148 of file OgreCamera.h.

CustomParameterMap Ogre::Renderable::mCustomParameters`[protected, inherited]`

| Definition at line 286 of file OgreRenderable.h.

bool Ogre::Frustum::mCustomProjMatrix`[protected, inherited]`

| Are we using a custom projection matrix? Definition at line 112 of file OgreFrustum.h.

bool Ogre::Frustum::mCustomViewMatrix`[protected, inherited]`

| Are we using a custom view matrix? Definition at line 110 of file OgreFrustum.h.

Quaternion Ogre::Camera::mDerivedOrientation`[mutable, protected]`

| Derived orientation/position of the camera, including reflection. Definition at line 95 of file OgreCamera.h.

Vector3 Ogre::Camera::mDerivedPosition`[mutable, protected]`

| Definition at line 96 of file OgreCamera.h.

Real Ogre::Frustum::mFarDist`[protected, inherited]`

| Far clip distance - default 10000. Definition at line 74 of file OgreFrustum.h.

Real Ogre::Frustum::mFocalLength`[protected, inherited]`

| Focal length of frustum (for stereo rendering, defaults to 1.0). Definition at line 82 of file OgreFrustum.h.

Radian Ogre::Frustum::mFOVy`[protected, inherited]`

| y-direction field-of-view (default 45) Definition at line 72 of file OgreFrustum.h.

Vector2 Ogre::Frustum::mFrustumOffset`[protected, inherited]`

| Off-axis frustum center offset - default (0.0, 0.0). Definition at line 80 of file OgreFrustum.h.

Plane Ogre::Frustum::mFrustumPlanes[6]`[mutable, protected, inherited]`

| The 6 main clipping planes. Definition at line 85 of file OgreFrustum.h.

Plane Ogre::Frustum::mLastLinkedObliqueProjPlane`[mutable, protected, inherited]`

| Record of the last world-space oblique depth projection plane info used. Definition at line 166 of file OgreFrustum.h.

Plane Ogre::Frustum::mLastLinkedReflectionPlane`[mutable, protected, inherited]`

| Record of the last world-space reflection plane info used. Definition at line 157 of file OgreFrustum.h.

Quaternion Ogre::Frustum::mLastParentOrientation`[mutable, protected, inherited]`

| Stored versions of parent orientation / position. Definition at line 88 of file OgreFrustum.h.

Vector3 Ogre::Frustum::mLastParentPosition`[mutable, protected, inherited]`

| Definition at line 89 of file OgreFrustum.h.

Viewport* Ogre::Camera::mLastViewport`[protected]`

| The last viewport to be added using this camera. Definition at line 142 of file OgreCamera.h.

LightList Ogre::MovableObject::mLightList`[mutable, protected, inherited]`

| List of lights for this object. Reimplemented in Ogre::StaticGeometry::Region. Definition at line 141 of file OgreMovableObject.h.

ulong Ogre::MovableObject::mLightListUpdated`[mutable, protected, inherited]`

| The last frame that this light list was updated in. Reimplemented in Ogre::StaticGeometry::Region. Definition at line 143 of file OgreMovableObject.h.

const MovablePlane* Ogre::Frustum::mLinkedObliqueProjPlane`[protected, inherited]`

| Pointer to oblique projection plane (automatically updated). Definition at line 164 of file OgreFrustum.h.

const MovablePlane* Ogre::Frustum::mLinkedReflectPlane`[protected, inherited]`

| Pointer to a reflection plane (automatically updated). Definition at line 155 of file OgreFrustum.h.

Listener* Ogre::MovableObject::mListener`[protected, inherited]`

| MovableObject listener - only one allowed (no list) for size & performance reasons. */. Definition at line 138 of file OgreMovableObject.h.

SceneManager* Ogre::MovableObject::mManager`[protected, inherited]`

| SceneManager holding this object (if applicable). Definition at line 105 of file OgreMovableObject.h.

MaterialPtr Ogre::Frustum::mMaterial`[protected, inherited]`

| Definition at line 145 of file OgreFrustum.h.

String Ogre::Camera::mName`[protected]`

| Camera name. Reimplemented from Ogre::MovableObject. Definition at line 84 of file OgreCamera.h.

Real Ogre::Frustum::mNearDist`[protected, inherited]`

| Near clip distance - default 100. Definition at line 76 of file OgreFrustum.h.

bool Ogre::Frustum::mObliqueDepthProjection`[protected, inherited]`

| Is this frustum using an oblique depth projection? Definition at line 160 of file OgreFrustum.h.

Plane Ogre::Frustum::mObliqueProjPlane`[mutable, protected, inherited]`

| Fixed oblique projection plane. Definition at line 162 of file OgreFrustum.h.

Quaternion Ogre::Camera::mOrientation`[protected]`

| Camera orientation, quaternion style. Definition at line 89 of file OgreCamera.h.

bool Ogre::MovableObject::mParentIsTagPoint`[protected, inherited]`

| Definition at line 108 of file OgreMovableObject.h.

Node* Ogre::MovableObject::mParentNode`[protected, inherited]`

| node to which this object is attached Definition at line 107 of file OgreMovableObject.h.

bool Ogre::Renderable::mPolygonModeOverrideable`[protected, inherited]`

| Definition at line 287 of file OgreRenderable.h.

Vector3 Ogre::Camera::mPosition`[protected]`

| Camera position - default (0,0,0). Definition at line 92 of file OgreCamera.h.

Matrix4 Ogre::Frustum::mProjMatrix`[mutable, protected, inherited]`

| Pre-calced standard projection matrix. Definition at line 96 of file OgreFrustum.h.

Matrix4 Ogre::Frustum::mProjMatrixRS`[mutable, protected, inherited]`

| Pre-calced projection matrix for the specific render system. Definition at line 92 of file OgreFrustum.h.

Matrix4 Ogre::Frustum::mProjMatrixRSDepth`[mutable, protected, inherited]`

| Pre-calced standard projection matrix but with render system depth range. Definition at line 94 of file OgreFrustum.h.

ProjectionType Ogre::Frustum::mProjType`[protected, inherited]`

| Orthographic or perspective? Definition at line 69 of file OgreFrustum.h.

uint32 Ogre::MovableObject::mQueryFlags`[protected, inherited]`

| Flags determining whether this object is included / excluded from scene queries. Definition at line 123 of file OgreMovableObject.h.

Quaternion Ogre::Camera::mRealOrientation`[mutable, protected]`

| Real world orientation/position of the camera. Definition at line 99 of file OgreCamera.h.

Vector3 Ogre::Camera::mRealPosition`[mutable, protected]`

| Definition at line 100 of file OgreCamera.h.

bool Ogre::Frustum::mRecalcFrustum`[mutable, protected, inherited]`

| Something's changed in the frustrum shape? Definition at line 100 of file OgreFrustum.h.

bool Ogre::Frustum::mRecalcFrustumPlanes`[mutable, protected, inherited]`

| Something re the frustum planes has changed. Definition at line 104 of file OgreFrustum.h.

bool Ogre::Frustum::mRecalcVertexData`[mutable, protected, inherited]`

| Something re the vertex data has changed. Definition at line 108 of file OgreFrustum.h.

bool Ogre::Frustum::mRecalcView`[mutable, protected, inherited]`

| Something re the view pos has changed. Definition at line 102 of file OgreFrustum.h.

bool Ogre::Camera::mRecalcWindow`[mutable, protected]`

| Definition at line 140 of file OgreCamera.h.

bool Ogre::Frustum::mRecalcWorldSpaceCorners`[mutable, protected, inherited]`

| Something re the world space corners has changed. Definition at line 106 of file OgreFrustum.h.

bool Ogre::Frustum::mReflect`[protected, inherited]`

| Is this frustum to act as a reflection of itself? Definition at line 149 of file OgreFrustum.h.

Matrix4 Ogre::Frustum::mReflectMatrix`[mutable, protected, inherited]`

| Derived reflection matrix. Definition at line 151 of file OgreFrustum.h.

Plane Ogre::Frustum::mReflectPlane`[mutable, protected, inherited]`

| Fixed reflection plane. Definition at line 153 of file OgreFrustum.h.

bool Ogre::MovableObject::mRenderingDisabled`[protected, inherited]`

| Does rendering this object disabled by listener? Definition at line 136 of file OgreMovableObject.h.

uint8 Ogre::MovableObject::mRenderQueueID`[protected, inherited]`

| The render queue to use when rendering this object. Definition at line 119 of file OgreMovableObject.h.

bool Ogre::MovableObject::mRenderQueueIDSet`[protected, inherited]`

| Flags whether the RenderQueue's default should be used. Definition at line 121 of file OgreMovableObject.h.

AnimableDictionaryMap Ogre::AnimableObject::msAnimableDictionary`[static, protected, inherited]`

| Static map of class name to list of animable value names. Definition at line 208 of file OgreAnimable.h.

PolygonMode Ogre::Camera::mSceneDetail`[protected]`

| Rendering type. Definition at line 108 of file OgreCamera.h.

Real Ogre::Camera::mSceneLodFactor`[protected]`

| Definition at line 125 of file OgreCamera.h.

Real Ogre::Camera::mSceneLodFactorInv`[protected]`

| Inverted scene LOD factor, can be used by Renderables to adjust their LOD. Definition at line 127 of file OgreCamera.h.

SceneManager* Ogre::Camera::mSceneMgr`[protected]`

| Scene manager responsible for the scene. Definition at line 86 of file OgreCamera.h.

uint32 Ogre::MovableObject::msDefaultQueryFlags`[static, protected, inherited]`

| Default query flags. Definition at line 147 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::msDefaultVisibilityFlags`[static, protected, inherited]`

| Default visibility flags. Definition at line 149 of file OgreMovableObject.h.

const PlaneList Ogre::Renderable::msDummyPlaneList`[static, protected, inherited]`

| Definition at line 284 of file OgreRenderable.h.

String Ogre::Camera::msMovableType`[static, protected]`

| Shared class-level name for Movable type. Reimplemented from Ogre::Frustum. Definition at line 117 of file OgreCamera.h.

Real Ogre::MovableObject::mSquaredUpperDistance`[protected, inherited]`

| Definition at line 113 of file OgreMovableObject.h.

Real Ogre::MovableObject::mUpperDistance`[protected, inherited]`

| Upper distance to still render. Definition at line 112 of file OgreMovableObject.h.

bool Ogre::Renderable::mUseIdentityProjection`[protected, inherited]`

| Definition at line 288 of file OgreRenderable.h.

bool Ogre::Renderable::mUseIdentityView`[protected, inherited]`

| Definition at line 289 of file OgreRenderable.h.

Any Ogre::MovableObject::mUserAny`[protected, inherited]`

| User defined link to another object / value / whatever. Definition at line 117 of file OgreMovableObject.h.

bool Ogre::Camera::mUseRenderingDistance`[protected]`

| Whether or not the rendering distance of objects should take effect for this camera. Definition at line 150 of file OgreCamera.h.

VertexData Ogre::Frustum::mVertexData`[mutable, protected, inherited]`

| Definition at line 143 of file OgreFrustum.h.

Matrix4 Ogre::Frustum::mViewMatrix`[mutable, protected, inherited]`

| Pre-calced view matrix. Definition at line 98 of file OgreFrustum.h.

unsigned int Ogre::Camera::mVisBatchesLastRender`[protected]`

| Stored number of visible faces in the last render. Definition at line 114 of file OgreCamera.h.

unsigned int Ogre::Camera::mVisFacesLastRender`[protected]`

| Stored number of visible faces in the last render. Definition at line 111 of file OgreCamera.h.

uint32 Ogre::MovableObject::mVisibilityFlags`[protected, inherited]`

| Flags determining whether this object is visible (compared to SceneManager mask). Definition at line 125 of file OgreMovableObject.h.

bool Ogre::MovableObject::mVisible`[protected, inherited]`

| Is this object visible? Definition at line 110 of file OgreMovableObject.h.

Real Ogre::Camera::mWBottom`[protected]`

| Viewing window. Remarks: Generalize camera class for the case, when viewing frustum doesn't cover all viewport. Definition at line 134 of file OgreCamera.h.

std::vector<Plane> Ogre::Camera::mWindowClipPlanes`[mutable, protected]`

| Windowed viewport clip planes. Definition at line 138 of file OgreCamera.h.

bool Ogre::Camera::mWindowSet`[protected]`

| Is viewing window used. Definition at line 136 of file OgreCamera.h.

Real Ogre::Camera::mWLeft`[protected]`

| Viewing window. Remarks: Generalize camera class for the case, when viewing frustum doesn't cover all viewport. Definition at line 134 of file OgreCamera.h.

AxisAlignedBox Ogre::MovableObject::mWorldAABB`[mutable, protected, inherited]`

| Cached world AABB of this object. Reimplemented in Ogre::ParticleSystem. Definition at line 127 of file OgreMovableObject.h.

Sphere Ogre::MovableObject::mWorldBoundingSphere`[mutable, protected, inherited]`

| Definition at line 129 of file OgreMovableObject.h.

AxisAlignedBox Ogre::MovableObject::mWorldDarkCapBounds`[mutable, protected, inherited]`

| World space AABB of this object's dark cap. Definition at line 131 of file OgreMovableObject.h.

Vector3 Ogre::Frustum::mWorldSpaceCorners[8]`[mutable, protected, inherited]`

| Definition at line 146 of file OgreFrustum.h.

Real Ogre::Camera::mWRight`[protected]`

| Viewing window. Remarks: Generalize camera class for the case, when viewing frustum doesn't cover all viewport. Definition at line 134 of file OgreCamera.h.

Real Ogre::Camera::mWTop`[protected]`

| Viewing window. Remarks: Generalize camera class for the case, when viewing frustum doesn't cover all viewport. Definition at line 134 of file OgreCamera.h.

bool Ogre::Camera::mYawFixed`[protected]`

| Whether to yaw around a fixed axis. Definition at line 103 of file OgreCamera.h.

Vector3 Ogre::Camera::mYawFixedAxis`[protected]`

| Fixed axis to yaw around. Definition at line 105 of file OgreCamera.h.

The documentation for this class was generated from the following file:

- OgreCamera.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:46:36 2008